(window.webpackJsonp=window.webpackJsonp||[]).push([[185],{1220:function(e,t){e.exports={attributes:{},body:'<div class="start-page__intro" markdown="1">\n\n# Welcome to\n\n## Argilla is a platform for building high-quality AI datasets\n\nIf you need support join the [Argilla Slack community](https://join.slack.com/t/rubrixworkspace/shared_invite/zt-whigkyjn-a3IUJLD7gDbTZ0rKlvcJ5g)\n\n</div>\n\n<div class="start-page__content" markdown="1">\n\nGet started by publishing your first dataset.\n\n### 1. Install the SDK with pip\n\nTo work with Argilla datasets, you need to use the Argilla SDK. You can install the SDK with pip as follows:\n\n```sh\npip install argilla -U --pre\n```\n\n### 2. Connect to your Argilla server\n\nGet your `ARGILLA_API_URL`:\n\n- If you are using Docker, it is the URL shown in your browser (by default `http://localhost:6900`)\n- If you are using HF Spaces, it should be constructed as follows: `https://[your-owner-name]-[your_space_name].hf.space`\n\nGet your `ARGILLA_API_KEY` you find in ["My settings"](/user-settings) and copy the API key.\n\nMake sure to replace `ARGILLA_API_URL` and `ARGILLA_API_KEY` in the code below. If you are using a private HF Space, you need to specify your `HF_TOKEN` which can be found [here](https://huggingface.co/settings/tokens).\n\n```python\nimport argilla as rg\n\nclient = rg.Argilla(\n    api_url="<api_url>",\n    api_key="<api_key>"\n    # extra_headers={"Authorization": f"Bearer {HF_TOKEN}"}\n)\n```\n\n### 3. Create your first dataset\n\nSpecify a workspace where the dataset will be created. Check your workspaces in ["My settings"](/user-settings). To create a new workspace, check the [docs](https://argilla-io.github.io/argilla/latest/how_to_guides/workspace/).\n\nHere, we are defining a creating a dataset with a text field and a label question ("positive" and "negative"), check the docs to [create a fully custom dataset](https://argilla-io.github.io/argilla/latest/how_to_guides/dataset/). Don\'t forget to replace "<your-workspace>".\n\n```python\nsettings = rg.Settings(\n    guidelines="Classify the reviews as positive or negative.",\n    fields=[\n        rg.TextField(\n            name="review",\n            title="Text from the review",\n            use_markdown=False,\n        ),\n    ],\n    questions=[\n        rg.LabelQuestion(\n            name="my_label",\n            title="In which category does this article fit?",\n            labels=["positive", "negative"],\n        )\n    ],\n)\ndataset = rg.Dataset(\n    name=f"my_first_dataset",\n    workspace="<your-workspace>",\n    settings=settings,\n    client=client,\n)\ndataset.create()\n```\n\n### 4. Add records\n\nYou can create a list with records that you want to add. Ensure that you match the fields with those specified in the question settings.\n\nYou can also use `pandas` or `datasets.load_dataset` to [read an existing dataset and create records from it](https://argilla-io.github.io/argilla/latest/how_to_guides/record/).\n\n```python\nrecords = [\n    rg.Record(\n        fields={\n            "review": "This is a great product.",\n        },\n    ),\n    rg.Record(\n        fields={\n            "review": "This is a bad product.",\n        },\n    ),\n]\ndataset.records.log(records)\n```\n\n</div>\n'}}}]);